<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_AdmAccounts extends Controller_Handler
{
    public function before() {
        parent::before();

        $this->user->checkAccess(User::RIGHTS_ADMIN);
    }


    public function action_getActivationForTeachers() {
        $faculty = Model_Faculty::with($this->post['facultyID']);
        $departments = $faculty->getDepartments();
        $departmentsHandled = [];
        $i = 0;

        foreach ($departments as $department) {
            $accounts = Model_Teachers::ofDepartment($department['ID']);
            if ($accounts == null)
                continue;

            $i++;
            $j = 0;
            $departmentsHandled[$i]['Name'] = $department['Name'];

            foreach ($accounts as $row) {
                # TODO: db query in loop
                $accInfo = Model_Account::with($row['AccountID']);
                if ($code = $accInfo->get('Code')) {
                    $j++;
                    $departmentsHandled[$i]['People'][$j]['LastName'] = $row['LastName'];
                    $departmentsHandled[$i]['People'][$j]['FirstName'] = $row['FirstName'];
                    $departmentsHandled[$i]['People'][$j]['SecondName'] = $row['SecondName'];
                    $departmentsHandled[$i]['People'][$j]['ActivationCode'] = $code;
                }
            }

            if ($j == 0) {
                $departmentsHandled[$i] = [];
                $i--;
            }
        }

        if ($i > 0) {
            $file = PDFCreator::CreatePDF(
                'pdf/activationTeacher',
                'media/css/pdf/activationTemplate.css', [
                    'Departments' => $departmentsHandled,
                    'System'      => [
                        'Title'   => ASSEMBLY_SYSTEM_NAME,
                        'Version' => ASSEMBLY_VERSION
                    ]
                ]);

            $headers = PDFCreator::GetHeaders($file, 'ActivationTeachers' . $faculty->ID);
            foreach ($headers as $key => $value) {
                $this->response->headers($key, $value);
            }

            $this->response->body($file);
        } else {
            throw HTTP_Exception::factory(400, 'No data found');
        }
    }

    public function action_getActivationForStudents() {
        $groups = Model_Faculty::with($_POST['facultyID'])->getGroups($_POST['gradeID']);
        $groupsHandled = [];
        $i = 0;

        foreach ($groups as $group) {
            $accounts = Model_Students::ofGroup($group['ID']);
            if (empty($accounts))
                continue;

            $i++;
            $j = 0;

            $groupsHandled[$i]['Grade'] = $_POST['gradeID'];
            $groupsHandled[$i]['Num'] = $group['GroupNum'];
            $groupsHandled[$i]['Spec'] = $group['SpecName'];

            foreach ($accounts as $row) {
                # TODO: db query in loop
                $accInfo = Model_Account::with($row['AccountID']);
                if ($code = $accInfo->get('Code')) {
                    $j++;
                    $groupsHandled[$i]['People'][$j]['LastName'] = $row['Last'];
                    $groupsHandled[$i]['People'][$j]['FirstName'] = $row['First'];
                    $groupsHandled[$i]['People'][$j]['SecondName'] = $row['Second'];
                    $groupsHandled[$i]['People'][$j]['ActivationCode'] = $code;
                }
            }

            if ($j == 0) {
                $groupsHandled[$i] = [];
                $i--;
            }
        }

        if ($i > 0) {
            $file = PDFCreator::CreatePDF(
                'pdf/activationStudent',
                'media/css/pdf/activationTemplate.css', [
                    'Groups' => $groupsHandled,
                    'System' => [
                        'Title'   => ASSEMBLY_SYSTEM_NAME,
                        'Version' => ASSEMBLY_VERSION
                    ]
                ]);

            $headers = PDFCreator::GetHeaders($file, 'ActivationStudents');
            foreach ($headers as $key => $value) {
                $this->response->headers($key, $value);
            }

            $this->response->body($file);
        } else {
            throw HTTP_Exception::factory(404, 'No data found');
        }
    }
}
