<?php defined('SYSPATH') or die('No direct script access.');

class Model_Account extends Model
{
    public static function setHashKey($key) {
        # TODO: not implemented
    }

    public static function getMaintenanceInfo() {
        $config = Model_System::loadConfig("general.json");

        $result['active'] = $config->Maintenance->active;
        $result['return'] = $config->Maintenance->return;
        return $result;
    }

    public static function checkAuth($login, $password) {
        $sql = "SELECT `SignIn`(:login, :pass) AS `ID`;";
        return DB::query(Database::SELECT, $sql)
            ->param(':login', $login)
            ->param(':pass', $password)
            ->execute()->get('ID');
    }


    public static function generateActivationCode() {
        $activationCode = Text::random('ABDCEFGHJKLMNPQRSTUVWXYZ123456789', 10);
        return UTF8::strtoupper($activationCode);
    }

    public static function createStudentEx($lastName, $firstName, $secondName, $gradeNum, $groupNum, $degree, $specialization, $facultyID, $semesterID = null) {
        $code = self::generateActivationCode();

        if (!$semesterID) $semesterID = Model_System::$SemesterID;

        $sql = "SELECT `CreateStudentEx`(:last, :first, :second, :grade, :group, :degree, :spec, :faculty, :code, :semester) AS `UserID`;";
        $response = DB::query(Database::SELECT, $sql)
            ->parameters([
                ':last'     => trim($lastName),
                ':first'    => trim($firstName),
                ':second'   => trim($secondName),
                ':grade'    => $gradeNum,
                ':group'    => $groupNum,
                ':degree'   => $degree,
                ':spec'     => $specialization,
                ':faculty'  => $facultyID,
                ':code'     => $code,
                ':semester' => $semesterID
            ])->execute()->get('UserID');

        return $response == -1 ? -1 : $code;
    }


    public static function with($id, $semesterID = null) {
        if ($id <= 0) throw new LogicException(Error::ID_IS_INCORRECT);

        $semesterID = $semesterID ? $semesterID : User::instance()->SemesterID;
        $sql = "CALL `GetFullInfo`(:id, :semester);";
        return DB::query(Database::SELECT, $sql)
            ->param(':id', (int) $id)
            ->param(':semester', (int) $semesterID)
            ->execute()[0];
    }


    public static function changeAccountData($accountID, $newPassword) {
        $sql = 'SELECT `ChangeAccountData`(:account, :value, "password") AS Num';
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':account' => $accountID,
                ':value'   => $newPassword,
            ])->execute()->get('Num');
    }

    public static function changeLogin($accountID, $newLogin) {
        $sql = 'SELECT `ChangeAccountData`(:account, :value, "login") AS Num';
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':account' => $accountID,
                ':value'   => $newLogin,
            ])->execute()->get('Num');
    }

    /**
     * @param string $data
     * @param string $type 'login','email' or 'code'
     * @return int
     */
    public static function checkAccountExistence($data, $type) {
        $sql = "SELECT `CheckAccountExistence`(:data, :type) AS Num;";
        return DB::query(Database::SELECT, $sql)
            ->param(':data', $data)
            ->param(':type', $type)
            ->execute()->get('Num');
    }

    public static function isActivationCodeValid($code) {
        $sql = "SELECT `CheckAccountExistence`(:acode, 'code') AS Num;";
        $res = DB::query(Database::SELECT, $sql)
            ->param(':acode', $code)
            ->execute()->get('Num');
        return $res == 1;
    }

    public static function createRecoveryToken($email, $token) {
        $sql = "SELECT `CreateRecoveryToken`(:email, :token) AS UserName;";
        return DB::query(Database::SELECT, $sql)
            ->param(':email', $email)
            ->param(':token', $token)
            ->execute()->get('UserName');
    }

    public static function getRecoveryInfoByEMail($email) {
        $sql = "CALL GetRecoveryInfoByEMail(:email);";
        return DB::query(Database::SELECT, $sql)
            ->param(':email', $email)
            ->execute();
    }

    public static function getRecoveryInfoByToken($token) {
        $sql = "CALL GetRecoveryInfoByToken(:token);";
        return DB::query(Database::SELECT, $sql)
            ->param(':token', $token)->execute();
    }

    public static function useRecoveryToken($token) {
        $sql = "SELECT `UseRecoveryToken`(:token) AS Num;";
        return DB::query(Database::SELECT, $sql)
            ->param(':token', $token)
            ->execute()->get('Num');
    }

    public static function activateAccount($login, $password, $email, $code) {
        $sql = "SELECT `ActivateAccount`(:code, :login, :email, :pass) AS `Num`;";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':code'  => $code,
                ':login' => $login,
                ':email' => $email,
                ':pass'  => $password,
            ])->execute()->get('Num');
    }

}
